<?
/*
###############################
#
# Counter plugin script for CC
# verified with CC versions 1.9x
# http://www.jkirkpatrick.org/
#
###############################
#
# Date: Jan 11, 2004
# Web: http://www.jkirkpatrick.org/
# Mail: plugins@jkirkpatrick.org
#
####################################
# This script is copyright 2004 by Jeremiah Kirkpatrick,
# All Rights Reserved.
#
#################################
01/23/04 Install/Uninstall Support
01/23/04 About Improvement
01/23/04 Resource Optimizations
01/23/04 Read Me added to the menu
02/06/04 Fixed Buggy Database Piggy-Back Support
03/01/04 Tracking Report Update
03/01/04 Updated path deturmination
03/02/04 Update Notification
03/03/04 - Global Session bug Fix
06/09/04 - Unique hit log bug fix
06/02/05 - Brought up to speed with php5
12/10/05 - Freeware Release
12/18/05 - Fix missing install/uninstall links and home site link
*/

$plugins[]=array("name"=>"Hit Counter", "classname"=>"hit_counter");
class hit_counter extends plugin_base
{
	var $class_name = "hit_counter";
	var $path = "counter/";
	var $author = "Jeremiah K.";
	var $web = "http://www.jkirkpatrick.org/";
	var $name = "Hit Counter (Freeware)";
	var $date = "12-18-05";
	var $table = "hit_counter";
	var $version = "1.11";
	var $validate;
	var $status;
	var $menu;
	var $file_name;
	var $missing_file="<font color=#FF0000>Missing or renamed required configuration file!</font>\n";
	function hit_counter()
	{
		global $mysql_database;
		$this->file_name = strtok($this->path, '/');
		$this->table = mysql_prefix.$this->table;
		$this->path=dirname(__FILE__).'/';
		$table_list=@mysql_list_tables($mysql_database);
		$this->menu="<h1 align=center>$this->name</h1>
		<p align=center><a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name\">Main</a>&nbsp|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=about\">About</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=readme\">Read Me</a>&nbsp|&nbsp\n";
		for ($i = 0; $i < @mysql_num_rows($table_list); $i++)
		{
		   $table=@mysql_tablename($table_list, $i);
			if($table == $this->table.'_data' || $_GET['page']=='install')
		      $this->status="&nbsp;|&nbsp;<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=uninstall\">Uninstall</a></p>";
		}

		if(!$this->status|| $_GET['page']=='uninstall')
		   $this->status="&nbsp;|&nbsp;<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&page=install\">Install </a></p>";
	}
	function admin_page()
	{
		global $HTTP_SESSION_VARS;
		echo "<h1 align=center>$this->name</h1>
		<p align=center><a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name\">Main</a>&nbsp|&nbsp;
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&tracking_report=1\">Tracking Report</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&hit_report=1\">Hit Report</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&readme=1\">Read Me</a>&nbsp|&nbsp
		<a href=\"$_SERVER[PHP_SELF]?p_load=$this->class_name&about=1\">About</a>".$this->status."</p>\n";
		if($_GET['hit_report'])
		{
			$this->hit_report();
			$this->page_footer();
		}
		else if($_GET['tracking_report'])
		{
			$this->tracking_report();
			$this->page_footer();
		}
		else if($_GET['about'])
		{
			$this->about();
			$this->page_footer();
		}
		else if($_GET['readme'])
		{
			$this->readme();
			$this->page_footer();
		}
		else
		{
			if(file_exists($this->path.'main.admin.php'))
				include($this->path.'main.admin.php');
			else
				echo $this->missing_file;
			$this->page_footer();
		}
	}
	function about()
	{
		$page=$this->path.'about.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo $this->missing_file;
	}
	function readme()
	{
		$page=$this->path.'README';
		if(file_exists($page))
		{
			echo "<PRE>\n";
			include($page);
			echo "</PRE>";
		}
		else
			echo $this->missing_file;
	}
	function hit_report()
	{
		$page=$this->path.'hreport.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo $this->missing_file;
	}
	function tracking_report()
	{
		$page=$this->path.'treport.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo $this->missing_file;
	}
	function public_page()
	{
		global $mysql_database, $userinfo, $HTTP_SESSION_VARS;
		$result=@mysql_query("SELECT * FROM ".$this->table."_conf");
		while($row=@mysql_fetch_array($result))
		   $conf[$row['name']]=$row['value'];
		$this->record();
		$today=mktime(date('h'),date('i'),date('s'),date("m"),date("d"),date("Y"));
		$today=date("Ymd", $today);
		$result=@mysql_query("SELECT * FROM ".$this->table."_data WHERE `name`='$today'");
		$htoday=@mysql_fetch_array($result);
		$result=@mysql_query("SELECT * FROM ".$this->table."_data WHERE `name`='total'");
		$htotal=@mysql_fetch_array($result);
		echo "<table align=\"center\" bgcolor=\"$conf[bgcolor]\" width=130px>
		<tr width=100%>
		<td align=\"center\">
		<font color=\"$conf[bgfont]\">
		Site Hit Statistics
		</font>
		<table align=\"center\" bgcolor=\"$conf[fgcolor]\" width=90%>
		<tr>
		<td align=\"left\"><font color=\"$conf[fgfont]\">Today:</font></td>
		<td align=\"left\"><font color=\"$conf[fgfont]\">$htoday[value]</font></td>
		</tr>
		<tr>
		<td align=\"left\"><font color=\"$conf[fgfont]\">Total:</font></td>
		<td align=\"left\"><font color=\"$conf[fgfont]\">$htotal[value]</font></td>
		</tr>
		</table>
		<font color=\"$conf[bgfont]\"></font><br>
		</td>
		</table>";
	}
	function record()
	{
		//session_start();
		global $mysql_database, $HTTP_SESSION_VARS;
		$results=@mysql_fetch_array(@mysql_query("SELECT count(*) AS cnt FROM ".$this->table."_tracking"));
		$cnt=$results['cnt'];
		$today=mktime(date('h'),date('i'),date('s'),date("m"),date("d"),date("Y"));
		$today=date("Ymd", $today);
		if(!$HTTP_SESSION_VARS['hit_counter'])
		{
			@mysql_query("UPDATE ".$this->table."_data SET value=value+1 WHERE `name`='total'");
			$now=@mysql_fetch_array(@mysql_query("SELECT * FROM ".$this->table."_data WHERE `name`='$today'"));
			if(!is_array($now))
			   $this->newday();
			@mysql_query("UPDATE ".$this->table."_data SET value=value+1 WHERE `name`='$today'");
			$HTTP_SESSION_VARS['hit_counter']=0;
		}
		$row=@mysql_fetch_array(@mysql_query("SELECT value FROM ".$this->table."_conf WHERE `name`='tracking'"));
		if($row[value])
			$this->track();
		$HTTP_SESSION_VARS['hit_counter']++;
	}
	function track()
	{
		global $mysql_database, $userinfo, $HTTP_SESSION_VARS;
		$results=@mysql_fetch_array(@mysql_query("SELECT count(*) AS cnt FROM ".$this->table."_tracking"));
		$cnt=$results['cnt'];
		$results=@mysql_query("SELECT * FROM ".$this->table."_conf");
		$tracking_data;
		$now=date('YmdHis');
		if($HTTP_SESSION_VARS['sessionref'])
		   $referer = $HTTP_SESSION_VARS['sessionref'];
		else
		   $referer = $_GET['refid'];
		while($row=@mysql_fetch_array($results))
		   $conf[$row['name']]=$row['value'];
		if(($conf['event']=='user') && ($HTTP_SESSION_VARS['username'] != $conf['object']))
		   return;
		if(($conf['event']=='ref') && ($referer != trim($conf['object'])))
		   return;
		if(($conf['event']=='unique') && ($HTTP_SESSION_VARS['hit_counter']>0))
		   return;
		if($cnt>=$conf['records'])
		{
		   $results = @mysql_fetch_array(@mysql_query("SELECT * FROM ".$this->table."_tracking ORDER BY `datetime` ASC LIMIT 1" ));
		   if($results)
		      @mysql_query("DELETE FROM ".$this->table."_tracking WHERE `datetime` ='$results[datetime]' AND `value`='$results[value]'");
		   $results=@mysql_fetch_array(@mysql_query("SELECT count(*) AS cnt FROM ".$this->table."_tracking"));
		   $cnt=$results['cnt'];
		}
		if($conf['ip'])
		   $tracking_data .= "%open".$this->ip()."%close";
		if($conf['username'])
		   $tracking_data .= "%open".$HTTP_SESSION_VARS['username']."%close";
		if($conf['request'])
		   $tracking_data .= "%open".$_SERVER['PHP_SELF']."%close";
		if($conf['referer'])
		   $tracking_data .= "%open".$referer."%close";
		if($conf['get'] && (getenv('REQUEST_METHOD')=='GET'))
		   $tracking_data .= "%open".getenv('QUERY_STRING')."%close";
		else
			if($conf['get'])
				$tracking_data .= "%open".""."%close";
		if($conf['post'] && (getenv('REQUEST_METHOD')=='POST'))
		   $tracking_data .= "%open".getenv('QUERY_STRING')."%close";
		else
			if($conf['post'])
				$tracking_data .= "%open".""."%close";
		if($conf['refpage'])
		{
			$refpage=getenv('HTTP_REFERER');
			if(strpos($refpage, '?'))
				$tracking_data .= "%open".strtok($refpage, '?')."%close";
			else
			   $tracking_data .= "%open".$refpage."%close";
		}
		@mysql_query("INSERT INTO ".$this->table."_tracking VALUES ('".$now."', '$tracking_data')");
	}
	function newday()
	{
		global $mysql_database;
		$today=mktime(date('h'),date('i'),date('s'),date("m"),date("d"),date("Y"));
		$delete=mktime(date('h'),date('i'),date('s'),date("m"),date("d")-7,date("Y"));
		$today=date("Ymd", $today);
		$delete=date("Ymd", $delete);
		@mysql_query("DELETE FROM ".$this->table."_data WHERE `name` =< '$delete'");
		@mysql_query("INSERT INTO ".$this->table."_data VALUES ('$today', '1')");
	}
	function ip()
	{
		if (getenv('HTTP_X_FORWARDED_FOR'))
		{
        		if(getenv('HTTP_CLIENT_IP'))
       			   return trim(getenv('HTTP_CLIENT_IP'));
			$tmp=getenv('HTTP_X_FORWARDED_FOR');
			if(strpos($tmp, ','))
			   return trim(strtok($tmp, ','));
			else
			   return trim($tmp);
		}else
			return trim(getenv('REMOTE_ADDR'));
	}
	function install()
	{
		$page=$this->path.'install.admin.php';
		if(file_exists($page))
			include($page);
		else
			echo $this->missing_file;
	}
	function uninstall()
	{
		@mysql_query("DROP TABLE ".$this->table."_conf");
		@mysql_query("DROP TABLE ".$this->table."_data");
		@mysql_query("DROP TABLE ".$this->table."_tracking");
	}
	function page_footer()
	{
		echo '<hr width=80%><table border="0" width="100%" align="center">
<tr bgcolor="#DDDDDD">
<td align="left" colspan="2"><p>These plugins are now offered as freeware to anybody who wishes to use them.</td>
</tr>';
	/*BEGIN COPYRIGHT NOTICE*/
	/*WARNING: TAMPERING WITH THIS SECTION OF CODE OR OTHERWISE CIRCUMVENTING IT'S EXECUTION BY BLOCKING OR REMOVING THE FUNCTION CALLS IS A VIOLATION IN THE FREEWARE LICENSE AGREEMENT WHICH GOVERNS YOUR USE OF THIS SCRIPT.*/
echo '<tr>
<td colspan="2" align="center">
'.$this->name.'<br>
&copy;2006 JKirkpatrick, All Rights Reserved<br>
</td>
</tr>';
	/*END COPYRIGHT NOTICE*/
echo '</table>';
	}
}
